<?php

/**************************************************************************
	CLASS:	collection
	PURPOSE:	handle specific processing for the collection object
**************************************************************************/

class DOCMGR_COLLECTION extends DOCMGR_AOBJECT
{

	function get()
	{
		return false;
	}
	
	function save()
	{

		//make sure it's saved as a document
		$this->apidata["object_type"] = "collection";

		$o = new DOCMGR_OBJECT($this->apidata);
		$o->save();	

		//toss and error if we have one
		$err = $o->getError();
		if ($err) $this->throwError($err[0],$err[1]);

	}

	function saveview()
	{

		$sql = "SELECT object_id FROM docmgr.object_view WHERE object_id='".$this->objectId."' AND account_id='".USER_ID."'";
		$info = $this->DB->single($sql);
		
		if ($info)	
		{
			$sql = "UPDATE docmgr.object_view SET view='".$this->apidata["account_view"]."' WHERE object_id='".$this->objectId."' AND account_id='".USER_ID."'";
		}
		else
		{
			$sql = "INSERT INTO docmgr.object_view (object_id,account_id,view) VALUES ('".$this->objectId."','".USER_ID."','".$this->apidata["account_view"]."');";
		}

		$this->DB->query($sql);
		
	}

	/***********************************************************************
		FUNCTION: update
		PURPOSE:	called by DOCMGR_OBJECT class DOCMGR_to perform additional processing
							for updating a collection
	***********************************************************************/
	protected function update($data) 
	{

		if ($data["default_view"]) $dv = $data["default_view"];

		$sql = null;
		
		//delete current values for default browsing view, and add new oens
		if ($dv)
		{
		 	$sql .= "DELETE FROM docmgr.object_view WHERE object_id='".$this->objectId."' AND account_id='0';";
			$sql .= "INSERT INTO docmgr.object_view (object_id,account_id,view) VALUES ('".$this->objectId."','0','".$dv."');";
		}

		$this->DB->query($sql);

	}

	/***********************************************************************
		FUNCTION: remove
		PURPOSE:	called by DOCMGR_OBJECT class DOCMGR_to perform additional processing
							for removing a collection
	***********************************************************************/
	protected function remove() 
	{

		$sql = "SELECT * FROM docmgr.dm_object_parent WHERE parent_id='".$this->objectId."';";
		$list = $this->DB->fetch($sql);

		//delete all objects under this parent.we pass our own id as parent so 
		//objects with multiple parents aren't removed completely 
		for ($i=0;$i<$list["count"];$i++) 
		{

			//init a new api for this object and delete it
			$obj = new DOCMGR_OBJECT($list[$i]["object_id"]);
			$obj->delete();

		}

		//reset everyone's home directory if they were using this one
		$sql = "UPDATE auth_settings SET home_directory='0' WHERE home_directory='".$this->objectId."'";
		if (!$this->DB->query($sql)) return false;

		//return true if we make it to here
		return true;

	}

	
	/***********************************************************************
	  Displaying:
	  This private function returns the link and the icon to be displayed
	  in the finder in list view
	  return $arr("link" => $link, "icon" => $icon);
	***********************************************************************/
	protected function listDisplay($info) 
	{
	
	  $arr["icon"] = THEME_PATH."/images/fileicons/folder.png";
	  $arr["link"] = "javascript:browseCollection('".$info["id"]."');";
	  return $arr;
	
	}
	
}

