<?
/*****************************************************************************************
  Fileame: app-config.php

  Purpose: Contains all settings external applications called by docmgr
           This is part of an effort to abstract out all program calls.  DocMGR should
           expect only a certain kind of response from the calling program.  The used program
           should contain the appropriate cli options to pass the desired output.
  Created: 05-07-2006

******************************************************************************************/

require_once("config/config.php");
loadAlternateConfig("app-config.php");

/********************************************
  DO NOT EDIT THE SETTINGS IN THIS FILE (config/app-config.php)!
  Add your own local settings to config/local/app-config.php in stead,
  otherwise you might loose your configuration when upgrading.
********************************************/


/************************************************************************
  paths and command line options for our apps
************************************************************************/

//path to openoffice3 installation
define("OPENOFFICE_PATH","/opt/openoffice.org3");

/***********************************************************************
  The apps in this section should be able to be replaced with another
  app as long as the output is the same
***********************************************************************/

//our ocr program.  All ocred content should be output to stdout
define("APP_OCR","ocrad --format=utf8");

//wget for url objects.  it should output everything to a file, taking
//<progname> -outputOpt <filename> <url-to-get>
define("APP_WGET","wget -O");

/************************************************************************
  The apps in this section are hard-coded for now
************************************************************************/

//xpdf
define("APP_PDFTOTEXT","pdftotext -nopgbrk -q");	//dont' remove the -nopgbrk option
define("APP_PDFIMAGES","pdfimages -q");

define("APP_SENDMAIL","sendmail");

//php cli binary
define("APP_PHP","php");

//clamav
define("APP_CLAMAV","clamscan");

//tiff processing
define("APP_TIFFINFO","tiffinfo");
define("APP_TIFFSPLIT","tiffsplit");

//imagemagick
define("APP_CONVERT","convert");
define("APP_MOGRIFY","mogrify");	//should convert all objects to pnm
define("APP_MONTAGE","montage");
define("APP_IDENTIFY","identify");

