<?php

class FILES
{

  private $errorMessage;
    
  /******************************************************
    FUNCTION:	getError
    PURPOSE:	returns an existing class error
  ******************************************************/  
  public function getError()
  {
    return $this->errorMessage;
  }
  
  /******************************************************
    FUNCTION:	throwError
    PURPOSE:	throws a class error
  ******************************************************/  
  public function throwError($err)
  {
    $this->errorMessage = $err;
  }
  
  /******************************************************
    FUNCTION:	display
    PURPOSE:	displays the form for entering config
              information
  ******************************************************/  
  public function display()
  {

    $content = "<h3>Filesystem Setup</h3>
                <p>The installer will now setup or update your DocMGR files directory</p>
                ";
                
    return $content;  
  
  }

  /******************************************************
    FUNCTION:	process
    PURPOSE:	writes our submitted values to the
              config file and saves the file
  ******************************************************/  
  public function process()
  {

    $this->checkFiles();
    
  }

  protected function checkFiles()
  {

    // define our constants here so that we get the correct ones
    // for those loaded from config and used below
    foreach ($_SESSION["config"] as $key => $value)
    {
      define(strtoupper($key), $value);
    }
    require_once("config/config.php");

    $this->createFileSubDir(DATA_DIR);
    $this->createFileSubDir(THUMB_DIR);
    $this->createFileSubDir(PREVIEW_DIR);
    $this->createFileSubDir(DOC_DIR);
    if (!is_dir(TMP_DIR)) mkdir(TMP_DIR);

  }

  //create our subdirectories for storage
  function createFileSubDir($path) 
  {

    //create our directory if it doesn't exist
    if (!is_dir($path)) mkdir($path, 700, true);

    //if it's not writable, error out
    if (!is_writable($path)) die("Error!".$path." is not writable by the webserver");

    //check to make sure it doesn't exist already
    if (!is_dir($path."/1")) 
    {

      //make our first level of directories
      for ($i=1;$i<=LEVEL1_NUM;$i++) 
      {

        $level1Data = $path."/".$i;
        @mkdir($level1Data);

        for ($c=1;$c<=LEVEL2_NUM;$c++) 
        {

          $level2Data = $level1Data."/".$c;
          @mkdir($level2Data);

        }

      }
 
    }

  }
  
}
