<?php

abstract class INSTALL_STEP
{
  protected $file = "<?\n";
  protected $filename = null;
  protected $entries = array();
  protected $emptyEntriesAllow = array();
  protected $errorMessage;

  /******************************************************
    FUNCTION:	getError
    PURPOSE:	returns an existing class error
  ******************************************************/  
  public function getError()
  {
    return $this->errorMessage;
  }
  
  /******************************************************
    FUNCTION:	throwError
    PURPOSE:	throws a class error
  ******************************************************/  
  public function throwError($err)
  {
    $this->errorMessage = $err;
  }
  
  /******************************************************
    FUNCTION:	display
    PURPOSE:	displays the form for entering config
              information
  ******************************************************/  
  public function display()
  {
  }

  /******************************************************
    FUNCTION:	process
    PURPOSE:	writes our submitted values to the
              config file and saves the file
  ******************************************************/  
  public function process()
  {
    global $errors;
    $this->loadFile();
    $this->storeConfigValues();
    $this->testConfig();
    
    if (!$this->getError() && count($errors) == 0)	$this->writeFile();

  }

  /******************************************************
    FUNCTION:	loadFile
    PURPOSE:	load our config template file
  ******************************************************/  
  protected function loadFile()
  {
    if($this->filename) {
      $localConf = "config/local/tmp/" . $this->filename;
  

      if ((file_exists($localConf) && !is_writable($localConf)) ||
	      (!file_exists($localConf) && !is_writable(dirname($localConf))))
      {
	$this->throwError("Local configuration output file '$localConf' isn't writable");
      }
    }
  }

  protected function storeConfigValues()
  {
    require_once("config/" . $this->filename);
    global $errors;


    foreach ($this->entries AS $entry)
    {

      //if we aren't submitted an entry, bail here
      if (!in_array($entry, $this->emptyEntriesAllow) && !$_POST[$entry])
      {
	$errors[$entry] = "Missing value";
	#$this->throwError("You did not fill out the \"".$entry."\" field");
	//break;
      }

      $name = strtoupper($entry);
      if (array_key_exists($entry, $_POST)) {
	if (!defined($name) || constant(strtoupper($entry)) != $_POST[$entry]) {
	  $this->file .= "define('$name', '$_POST[$entry]');\n";
	}
      }
    }

  }

  protected function testConfig()
  {
  }

  /******************************************************
    FUNCTION:	writeFile
    PURPOSE:	write our config template file
  ******************************************************/  
  protected function writeFile()
  {
    global $errors;

    if ($this->getError() && count($errors) == 0) return false;

    if($this->filename) {
      $localConf = "config/local/tmp/" . $this->filename;

      if (!file_put_contents($localConf,$this->file))
      {
	$this->throwError("Unable to write config file '$localConf'");
      }

    }
  }

}
