<?

/**********************************************************************
  CLASS: API
  PURPOSE:	A standalone library that code that exists outside
            of the tea module system (like scripts) can use to
            access the api
  INPUTS:		login -> api login
            password -> api password
**********************************************************************/

//get our core includes
ini_set("include_path",".:".ALT_FILE_PATH);

//get header file
include("apilib/header.php");

class APICLIENT
{

  private $login;
  private $password;
  private $sessid;
  
  function __construct($login,$password)
  {

  	global $DB,$CDB,$PROTO,$logger;
  
    $_REQUEST["login"] = $login;
    $_REQUEST["password"] = $password;

    //get header file
    include("apilib/preauth.php");
	
    //do we authorize people in this site to access any module
    include("apilib/auth.php");
    $a = new AUTH();
		
		//stop here if login error
		if ($err = $a->getError()) 
		{
			
			$PROTO->add("error",$err);
			
		} 
		else if (!$_SESSION["api"]["authorize"]) 
		{
		
			//if not authorized but don't have an error message, show a generic error 
			$PROTO->add("error","Could not log into api");
		
		} 
		else
		{

			//not sure if we still need this or not
			define("THEME_PATH","themes/".SITE_THEME);

		}

  }

  function call($opt)
  {

  	global $DB,$CDB,$PROTO,$logger;

  	$PROTO->setData(null);

  	$_REQUEST = $opt;
	
		//for handling requests
		include("apilib/request.php");

		$data = $PROTO->getData();
		
		return $data;
		
	}

}
