var curobj;
var objtype;
var objpath;
var objname;
var parentpath;
var createmode;
var remotesaved;
var readonly;
var ceiling;
var fck;
var savecontent = "";

var mbmode;
var timer;

window.onresize = setFrameSize;
window.onbeforeunload = checkState;
window.onunload = refreshParent;

/*******************************************************************
	FUNCTION: loadPage
	PURPOSE:	initializes and loads the editor
*******************************************************************/
function loadPage() {

	curobj = ge("objectId").value;
	objtype = ge("objectType").value;
	objpath = ge("objectPath").value;
	objname = ge("objectName").value;
	parentpath = ge("parentPath").value;
	createmode = ge("createMode").value;

	if (!objtype) objtype = "document";

	if (!curobj) {

		clearSiteStatus();	
		remotesaved = 0;
		loadEditor();

	} else {

		//if there's an object passed, use it
		if (curobj.length>0) {

			updateSiteStatus("Loading " + objtype);

			//snag the document converted to html for us
			if (objtype=="file") getFileContent();
			else getDocumentContent();

		//open blank document
		} else {

			remotesaved = 0;
			clearSiteStatus();

		}

	}

}

/*******************************************************************
	FUNCTION: loadEditor
	PURPOSE:	load the actual editor.  
	INPUTS:		curval -> html we'll populate the editor with
*******************************************************************/
function loadEditor(curval) {

    var ed = ce("div","","editor_content");
		ge("editorDiv").appendChild(ed);

    //create a new one
    var f = CKEDITOR.replace(ed);

		if (curobj) var ip = parentpath + "/.object" + curobj + "_storage";
		else var ip = "/Users/" + USER_LOGIN + "/.temp_storage";

    f.config.image_mode = "docmgr";
    f.config.image_path = ip;
    f.config.toolbar = 'Docmgr';
    f.config.fullPage = true;
    f.on("pluginsLoaded",function (ev) { addDialogs(f); });
		f.on("instanceReady",function (ev) { setFrameSize(); });
    if (curval) f.setData(curval);

	clearSiteStatus();

}

/*******************************************************************
	FUNCTION: getDocumentContent
	PURPOSE:	get the html for the specified document
*******************************************************************/
function getDocumentContent() {

	objtype = "document";

	var p = new PROTO();
	p.add("command","docmgr_document_get");
	p.add("object_id",curobj);
	p.add("lock","1");
	p.post(DOCMGR_API,"writeDocumentContent");

}

/*******************************************************************
	FUNCTION: writeDocumentContent
	PURPOSE:	response handler for getDocumentContent.  Populates
						the editor with the html returned from docmgr
	INPUTS:		resp -> ajax response
*******************************************************************/
function writeDocumentContent(data) {

	clearSiteStatus();

	if (data.error) alert(data.error);
	else 
	{

		//set filesaved so we automatically overwrite
		if (objtype=="file") remotesaved = 0;
		else remotesaved = 1;

		if (data.locked && data.locked=="t") readonly = "locked";
		else if (data.bitmask_text=="view") readonly = "view";
		else readonly = "";

		setReadonly();

		if (!data.content) data.content = "";

		loadEditor(data.content);

	}

}

function setReadonly() 
{

	var rc = ge("readonlyCell");

	if (readonly) 
	{

		if (readonly=="locked") rc.appendChild(ctnode("Read-only.  Locked by another user"));
		else rc.appendChild(ctnode("Read-only"));

	}
	else clearElement(ge("readonlyCell"));

}

/*******************************************************************
	FUNCTION: getFileContent
	PURPOSE:	get the html for the specified file.  The file is
						called by docmgr and convert to html.  that html is
						returned to here
*******************************************************************/
function getFileContent() {

	objtype = "file";

	var p = new PROTO();
	p.add("command","docmgr_file_getashtml");
	p.add("object_id",curobj);
	p.post(DOCMGR_API,"writeDocumentContent");

}

/*********************************************
  FUNCTION: checkState
  PURPOSE:  checks if file needs to be saved
*********************************************/
function checkState() {

	if (CKEDITOR.instances.editor_content.checkDirty())
	{
		return "You have made changes to this document since it was last saved.";
	}


}

/*********************************************
  FUNCTION: refreshParent
  PURPOSE:  reloads parent page when we're done here
*********************************************/

function refreshParent() 
{

	//if we have an object, make sur eit's unlocked
	if (curobj)
	{

		//unlock our document
		var p = new PROTO();
		p.add("command","docmgr_lock_clear");
		p.add("object_id",curobj);
		p.setAsync(false);
		p.post(DOCMGR_API);

	}

	if (window.opener.closeWindow) 
	{
		window.opener.closeWindow();
	} 
	else 
	{  
		var url = window.opener.location.href;
		window.opener.location.href = url;
	}


}

/*******************************************************************
	FUNCTION: saveCopyToServer
	PURPOSE:	saves a copy of the current file to docmgr
	INPUTS:		none
*******************************************************************/
function saveCopyToServer() {

	//clear the fact that it's saved and allow newly named copy
	remotesaved = 0;
	saveToServer();

}

/*******************************************************************
	FUNCTION: saveToServer
	PURPOSE:	saves an existing file to the server, or spawns the 
						docmgr file browser to pick a place/name to save the
						open new file
	INPUTS:		none
*******************************************************************/
function saveToServer() {

	//if we've already saved this file once, just save it directly
	if (remotesaved == 1 && !readonly) 
	{

		runServerSave();

	//spawn minib to pick where to save the file
	} else 
	{

		mbmode = "save";
		curobj = "";

		//launch our selector to pick where to save the file
		var parms = centerParms(600,460,1) + ",resizable=no,scrollbars=no";

		var url = "index.php?module=minib&mode=save&browsePath=" + parentpath;
		url += "&objectTypeFilter=document,collection";
		var ref = window.open(url,"_minib",parms);
		ref.focus();

	}

}

/*******************************************************************
	FUNCTION: runServerSave
	PURPOSE:	posts the document content to docmgr for saving, 
						along with the path to save it to
	INPUTS:		none
*******************************************************************/
function runServerSave() {

	updateSiteStatus("Saving Document");

	//make sure we have the latest path set
	ge("objectId").value = curobj;
	ge("objectPath").value = objpath;

	//update or create
	

	//setup xml
	var p = new PROTO();
	p.add("command","docmgr_document_save");
	p.add("parent_path",parentpath);			//pass the path too so we know where to put it (parent folder)
	p.add("name",objname);
	if (curobj) p.add("object_id",curobj);
	p.add("lock","1");
	p.add("editor_content",CKEDITOR.instances.editor_content.getData());
	p.post(DOCMGR_API,"writeServerSave");

}

/*******************************************************************
	FUNCTION: writeServerSave
	PURPOSE:	response handler for runServerSave
	INPUTS:		resp -> ajax response
*******************************************************************/
function writeServerSave(data) {

	clearSiteStatus();

	if (data.error) alert(data.error);
	else {

		//show it's been saved
		CKEDITOR.instances.editor_content.resetDirty();

		//save the objectid
		remotesaved = 1;
		readonly = "";
		curobj = data.object_id;
		ge("objectId").value = curobj;

	}
	
}

/*******************************************************************
	FUNCTION: openServerFile
	PURPOSE:	spawns minib to pick a file/document to open
	INPUTS:		none
*******************************************************************/
function openServerFile() {

	remotesaved = 0;

	mbmode = "open";

	var parms = centerParms(600,460,1) + ",resizable=no,scrollbars=no";

	var url = "index.php?module=minib&objectId=" + curobj;
	url += "&objectTypeFilter=document,file,collection";

	var ref = window.open(url,"_minib",parms);
	ref.focus();

}


/*******************************************************************
	FUNCTION: mbSelectObject
	PURPOSE:	called by minib dialog.  returns the selected document
						information
	INPUTS:		res -> array containing document info
*******************************************************************/
function mbSelectObject(res) {

	if (!res) {
		alert("Error selecting object");
		return false;
	} 

	//store our globals
	objname = res.name;
	parentpath = res.parent;

	//handle a save operation
	if (mbmode=="save") {

		updateSiteStatus("Saving File");
		setTimeout("runServerSave()","10");			//have to use settimeout to give the popup time to close
		return false;

	//handle an open operation
	} else {

		//store additional globals since we are selecting a file
		curobj = res.id; 
		objpath = res.path;

		updateSiteStatus("Opening File");
		ge("objectId").value = curobj;

	  	//if it is a document, get the html from docmgr
	  	if (objtype=="document") {
	    		setTimeout("getDocumentContent()","10");
	  	} else if (type=="file") {
	    		//otherwise pull the file and convert it to html
	    		setTimeout("getFileContent()","10");
	  	} 	

	}

}


/*******************************************************************
	FUNCTION: printDocument
	PURPOSE:	prints the document to a pdf file
	INPUTS:		none
*******************************************************************/
function printDocument(preview) {

	if (!curobj) alert("You must save this document before you can print it");
	else {

		ge("editorContent").value = CKEDITOR.instances.editor_content.getData();

		if (ge("taskId").value.length > 1)
		{

			if (preview) ge("printpreview").value = 1;
			else
			{

				var msg = "After the document prints, the task will be marked complete.  If you do not";
				msg += " wish this to occur, click \"Cancel\" and use \"Print Preview\"";

				if (!confirm(msg)) return false;

			}

		}

		ge("action").value = "print";
		document.pageForm.submit();
		ge("action").value = "";

	}

}

/*******************************************************************
	FUNCTION: setFrameSize
	PURPOSE:	sets the fckeditor to fill the window when resized
	INPUTS:		none
*******************************************************************/
function setFrameSize() {

  var ref = ge("cke_contents_editor_content");
	var base = 175;

  ref.style.height = (getWinHeight() - base) + "px";

}
 

function insertMergeField(val) {

  val += " ";

	CKEDITOR.instances.editor_content.insertHtml(val);

}
