
/********************************************************************
	FILENAME: javascript.js
	PURPOSE:  contains common contact editing related functions

*********************************************************************/

//globals
var object = "";
var objinfo;
var curpage = "objprop";
var container;
var content;
var tbBtns;
var tbTitle;
var savehandler;
var ceiling;
var filetasks;

/****************************************************************
	FUNCTION: loadPage
	PURPOSE:  loads our page for the first time
	INPUT:	  none
*****************************************************************/	

function loadPage(pload) {

	//set globals from our input fields
	object = ge("objectId").value;
	ceiling = BROWSE_CEILING;
	if (ceiling.length==0) ceiling = "/";

	//store these for easy access
	container = ge("container");
	content = ge("content");

	//load our navigation
	loadToolbar();

	//update our site nav history
	ge("siteNavHistory").innerHTML = ge("objectNav").innerHTML;

	//set the function to run after we get our objct info
	if (pload) objpage = pload;

	updateSiteStatus("Getting object information");

	//get our object information, then load the properties page when finished
	loadObjInfo();
	endReq("getWorkflowTasks()");

}

function getWorkflowTasks() {

	//setup command to get object info
	var p = new PROTO();
	p.add("command","docmgr_workflow_gettasks");
	p.add("object_id",object);
	p.post(DOCMGR_API,"writeWorkflowTasks");

}

function writeWorkflowTasks(data) {

	clearSiteStatus();

	if (data.error) alert(data.error);
	else 
	{
		if (data.task) 
		{
			menuEntry('My Tasks','filetasks');
			filetasks = data.task;
		} else {

			//remove the menu entry if it's there

			filetasks = "";
			var arr = moduleNav.getElementsByTagName("div");

			for (var i=0;i<arr.length;i++)
			{

				if (arr[i].innerHTML.indexOf("My Tasks")!=-1)
				{
					arr[i].parentNode.removeChild(arr[i]);
					break;
				}

			}

		}
	}

}

/****************************************************************
	FUNCTION: loadObjectPage
	PURPOSE:  runs the appropriate load function based on the passed
						page name
	INPUT:	  page -> name of the page we are loading
*****************************************************************/	

function loadObjectPage(page) {

	if (page) curpage = page;
	updateSiteStatus("Loading Page");

	switch (curpage) {

		case "properties":
			historyManager("loadProperties","Object Properties");
			break;

		case "permissions":
			historyManager("loadPermissions","Object Permissions");
			break;

		case "parents":
			historyManager("loadObjParents","Object Parents");
			break;

		case "history":
			historyManager("loadFileHistory","Revision History");
			break;

		case "logs":
			historyManager("loadObjLogs","Object Logs");
			break;

		case "discussion":
			historyManager("loadDiscussion","Discussion");
			break;

		case "workflow":
			historyManager("loadWorkflow","Workflow");
			break;

		case "checkin":
			historyManager("loadCheckin","File Checkin");
			break;

		case "filetasks":
			historyManager("loadFileTasks","My Tasks");
			break;

		case "viewfile":
			historyManager("viewFile","");
			break;

		case "managesubscription":
			historyManager("propManageSubscription","");
			break;

	}

}

/****************************************************************
	FUNCTION: loadToolbar
	PURPOSE:  setups up toolbar for main contact page
	INPUT:    none
*****************************************************************/

function loadToolbar() {

	tbBtns = ge("toolbarBtns");
	tbTitle = ge("toolbarTitle");

}

function save() {

	var func = eval(savehandler);

}

/****************************************************************
	FUNCTION: loadMenu
	PURPOSE:  creates our left column nav menu
	INPUT:    none
*****************************************************************/

function loadMenu() {

	showModNav();

	menuEntry("Properties","properties");

	if (objinfo.bitmask_text=="admin")
	{

		menuEntry("Parent Collection","parents");
		menuEntry("Permissions","permissions");
		menuEntry("Revision History","history");

	}

	if (objinfo.bitmask_text=="edit" || objinfo.bitmask_text=="checkin" || objinfo.bitmask_text=="admin")
	{
		menuEntry("Check-out/Check-in","checkin");
	}

	menuEntry("Logs","logs");
	menuEntry("Discussion","discussion");
	menuEntry("Workflow","workflow");
	addModSpacer();
	menuEntry("View File","viewfile");
	menuEntry("Manage Subscription","managesubscription");

}

/****************************************************************
	FUNCTION: menuEntry
	PURPOSE:  creates one entry for our nav menu
	INPUT:    none
*****************************************************************/

function menuEntry(title,page) {

	var link = "loadObjectPage('" + page + "')";

	addModNav(title,link);	

}

