var curtask;
var taskcont;

function loadFileTasks() {

  if (!object) return false;

	if (!filetasks)
	{
		//setup command to get object info
  	var p = new PROTO();
  	p.add("command","docmgr_workflow_gettasks");
  	p.add("object_id",object);
		p.setAsync(false);

  	var d = p.post(DOCMGR_API);
		filetasks = d.task;

	}

	loadTaskPage();
	
}

function loadTaskPage() {

  clearElement(content);
	taskcont = ce("div","taskContainer");
  loadFTToolbar();

	content.appendChild(taskcont);
	loadTaskSwitcher();

	switchTask();

	clearSiteStatus();

}

function loadTaskSwitcher() {

	var cell = ce("div","taskCell");
	cell.appendChild(ce("div","formHeader","","Select Task"));

	var sel = createSelect("taskId");
	setChange(sel,"switchTask()");

	for (var i=0;i<filetasks.length;i++) {
		sel[i] = new Option(filetasks[i].title,filetasks[i].id);
	}

	cell.appendChild(sel);
	content.appendChild(cell);

}

function loadFTToolbar() {

  clearElement(tbBtns);
  clearElement(tbTitle);

	if (curtask) {

  	tbBtns.appendChild(siteToolbarCell("Mark Complete","completeTask()","save.png"));

		//if an approval task, add a rejection button
		if (curtask.task_type=="approve") {
	  	tbBtns.appendChild(siteToolbarCell("Reject Approval","rejectTask()","delete.png"));
		}

	}

}

function switchTask() {

	var id = ge("taskId").value;
	curtask = "";

	for (var i=0;i<filetasks.length;i++) {
		if (filetasks[i].id==id) {
			curtask = filetasks[i];
			break;
		}
	}

	if (curtask) {

		loadCurrentTask();

	} else alert("Error retrieving task information");	

}

function loadCurrentTask() {

	clearElement(taskcont);
	loadFTToolbar();

	var account = ce("div","taskCell");
	account.appendChild(ce("div","formHeader","","Submitted By"));
	account.appendChild(ctnode(curtask.workflow_account_name));
	taskcont.appendChild(account);

	if (isData(curtask.date_due)) 
	{

		var dd = ce("div","taskCell");
		dd.appendChild(ce("div","formHeader","","To Be Completed By"));
		dd.appendChild(ctnode(curtask.date_due));
		taskcont.appendChild(dd);

	}

	taskcont.appendChild(createTaskLink());
	taskcont.appendChild(createTaskComment());

}

function createTaskLink() {

	var cont = ce("div","taskCell");

	//show view links for view and approval tasks, edit for edit
	if (curtask.route_task_type=="edit") {

		cont.appendChild(ce("div","formHeader","","Please make necessary edits to file, then mark task complete"));
		cont.appendChild(createLink("[Edit File]","javascript:editTaskFile()"));

	} else {

		cont.appendChild(ce("div","formHeader","","Please view file, then mark task complete"));
		cont.appendChild(createLink("[View File]","javascript:viewTaskFile()"));

	}

	return cont;

}

//creates the form for note entry
function createTaskComment() {

  var commdiv = ce("div","taskCell");
  var commheader = ce("div","formHeader","","Comments");
  var commform = createTextarea("taskComment");

  commdiv.appendChild(commheader);
  commdiv.appendChild(commform);

  return commdiv;

}

function completeTask() {

	updateSiteStatus("Marking complete");

	var rid = "";
	var cur = ge("taskId").value;

	//get the route id
	for (var i=0;i<filetasks.length;i++)
	{
		if (filetasks[i].id==cur)
		{
			rid = filetasks[i].route_id;
			break;
		}
	}
	
	var p = new PROTO();
  p.add("command","docmgr_workflow_markcomplete");
  p.add("route_id",rid);
	p.add("object_id",object);
	p.add("taskComment",ge("taskComment").value);
	p.post(DOCMGR_API,"writeCompleteTask");

}

function writeCompleteTask(data)
{

	clearSiteStatus();

	if (data.error) alert(data.error);
	else 
	{
		loadProperties();
		getWorkflowTasks();
	}

}


function viewTaskFile() 
{

	var objid = objinfo.id;
	var ext = fileExtension(objinfo.name);

  //handle microsoft office extensions for internet explorer
  if (DSOFRAMER_ENABLE==1 && document.all && arraySearch(ext,DSO_FILES)!="-1")
	{

    var url = "index.php?module=editor&objectId=" + objid;
    var parms = centerParms(800,600,1) + ",resizable=1";  
    popupref = window.open(url,"_editor",parms);
    popupref.focus();

  //download like normal
  } else {

    //setup the xml
		var p = new PROTO();
    p.add("command","docmgr_file_get");
    p.add("object_id",objid);  
		p.redirect(DOCMGR_API);

  }

}  

function editTaskFile() 
{

	var objid = objinfo.id;
	var ext = fileExtension(objinfo.name);

  //handle microsoft office extensions for internet explorer
  if (DSOFRAMER_ENABLE==1 && document.all && arraySearch(ext,DSO_FILES)!="-1")
	{

    var url = "index.php?module=editor&objectId=" + objid;
    var parms = centerParms(800,600,1) + ",resizable=1";  
    popupref = window.open(url,"_editor",parms);
    popupref.focus();

  } 
  //checkout the file for editing locally
	else 
	{

		var p = new PROTO();
    p.add("command","docmgr_file_get");
    p.add("object_id",objid);  
		p.add("lock",1); 
		p.redirect(DOCMGR_API);

  }

}  

