/***********************************************
	file for editing object properties
***********************************************/

var worklist;
var workcont;
var curwork;

function loadWorkflow() {

	if (!object) return false;

	updateSiteStatus("Loading workflow");

	clearElement(content);
	loadWorkToolbar();

	//stores our workflow history
	worklist = ce("div","workflowList");

	var listhead = ce("div","workflowListHeader");
	listhead.appendChild(ce("div","","","Status"));
	listhead.appendChild(ce("div","","","Date Created"));
	listhead.appendChild(ce("div","","","Date Completed"));

	//setup site structure
	var leftcol = ce("div","workflowLeft");
	leftcol.appendChild(ce("div","formHeader","","Workflow History"));
	leftcol.appendChild(listhead);
	leftcol.appendChild(createCleaner());
	leftcol.appendChild(ce("div","","",worklist));

	//workflow detail
	workcont = ce("div","workflowRight");

	content.appendChild(workcont);
	content.appendChild(leftcol);
	content.appendChild(createCleaner());

	loadWorkflowList();

	if (curwork) viewWorkflow(curwork.id);

}

function loadWorkToolbar() {

	clearElement(tbBtns);
	clearElement(tbTitle);

	tbBtns.appendChild(siteToolbarCell("New Workflow","newWorkflow()","new.png"));

	if (curwork) {

		tbBtns.appendChild(siteToolbarCell("Edit Recipients","editRecipient()","edit.png"));

		if (curwork.status=="nodist") {
			tbBtns.appendChild(siteToolbarCell("Begin Workflow","beginWorkflow()","save.png"));
		} else if (curwork.status=="pending") {
			tbBtns.appendChild(siteToolbarCell("Force Complete","forceComplete()","delete.png"));
		}

	}

}


function loadWorkflowList() {

	var p = new PROTO();
	p.add("command","docmgr_workflow_getlist");
	p.add("object_id",object);
	p.post(DOCMGR_API,"writeWorkflowList");

}

function writeWorkflowList(data) {

	clearSiteStatus();
	clearElement(worklist);
	 
	if (data.error) alert(data.error);
	else if (!data.workflow) worklist.appendChild(ce("div","errorMessage","","No entries found to display"));
	else {

		for (var i=0;i<data.workflow.length;i++) {

			w = data.workflow[i];

			//create row for workflow list
			var row = ce("div","workflowRow");
			setClick(row,"viewWorkflow('" + w.id + "')");

			//the status and a link to view the workflow
			row.appendChild(ce("div","","",w.status_view));
			row.appendChild(ce("div","","",w.date_create_view));

			if (!isData(w.date_complete_view)) w.date_complete_view = "Not Complete";
			row.appendChild(ce("div","","",w.date_complete_view));

			row.appendChild(createCleaner());

			worklist.appendChild(row);

		}

		worklist.appendChild(createCleaner());

	}

}

function newWorkflow() {

	updateSiteStatus("Creating new workflow");

	var p = new PROTO();
	p.add("command","docmgr_workflow_create");
	p.add("object_id",object);
	p.post(DOCMGR_API,"writeWorkflowInfo");

	endReq("loadWorkflowList()");

}

function viewWorkflow(id) {

	updateSiteStatus("Loading workflow information");

	var p = new PROTO();
	p.add("command","docmgr_workflow_getinfo");
	p.add("workflow_id",id);
	p.add("object_id",object);
	p.post(DOCMGR_API,"writeWorkflowInfo");

}

function writeWorkflowInfo(data) {

	clearSiteStatus();
	clearElement(workcont);
	
	curwork = "";
	 
	if (data.error) alert(data.error);
	else if (!data.workflow) worklist.appendChild(ce("div","errorMessage","","No entries found to display"));
	else {

		//store for later
		curwork = data.workflow[0];
		loadWorkToolbar();

		//output the info
		var workcell = ce("div","workflowCell");
		workcell.appendChild(ce("div","formHeader","","Workflow Status"));
		workcell.appendChild(ce("div","","",curwork.status_view));
		workcont.appendChild(workcell);		

		//output the info
		var workcell = ce("div","workflowCell");
		workcell.appendChild(ce("div","formHeader","","Date Created"));
		workcell.appendChild(ce("div","","",curwork.date_time_create_view));
		workcont.appendChild(workcell);		

		if (isData(curwork.date_complete)) 
		{

			//output the info
			var workcell = ce("div","workflowCell");
			workcell.appendChild(ce("div","formHeader","","Date Completed"));
			workcell.appendChild(ce("div","","",curwork.date_time_complete_view));
			workcont.appendChild(workcell);		

		}

		//output the info
		var workcell = ce("div","workflowCell");
		workcell.appendChild(ce("div","formHeader","","Recipients"));
		var reciplist = ce("div","workflowRecips");
		
		if (curwork.recipient) {

			for (var i=0;i<curwork.recipient.length;i++) {

				var row = ce("div","workRecipRow");

				var acc = ce("div");
				acc.appendChild(ce("span","workflowRecipAccount","",curwork.recipient[i].account_login));
				acc.appendChild(ce("span","workflowRecipStatus",""," (" + curwork.recipient[i].status_view + ")"));

				row.appendChild(acc);
				if (!isData(curwork.recipient[i].comment)) curwork.recipient[i].comment = "No comment posted";
				row.appendChild(ce("div","workflowRecipComment","",curwork.recipient[i].comment));

				reciplist.appendChild(row);
				
			}

		} else reciplist.appendChild(ce("div","errorMessage","","No recipients found"));

		workcell.appendChild(reciplist);
		workcont.appendChild(workcell);		

	}

}

function beginWorkflow() {

	updateSiteStatus("Creating new workflow");

	var p = new PROTO();
	p.add("command","docmgr_workflow_begin");
	p.add("object_id",object);
	p.add("workflow_id",curwork.id);
	p.post(DOCMGR_API,"writeBeginWorkflow");

}

function writeBeginWorkflow(data) {

	if (data.error) alert(data.error);
	else 
	{
		viewWorkflow(curwork.id);
		getWorkflowTasks();
	}

}

function forceComplete() {

	updateSiteStatus("Creating new workflow");

	var p = new PROTO();
	p.add("command","docmgr_workflow_forcecomplete");
	p.add("object_id",object);
	p.add("workflow_id",curwork.id);
	p.post(DOCMGR_API,"writeForceComplete");

}

function writeForceComplete(data) {

	 
	if (data.error) alert(data.error);
	else 
	{
		clearElement(worklist);
		loadWorkflowList();
		getWorkflowTasks();
	}

}

